<template>
  <v-form ref="form" v-model="valid" lazy-validation>
    <v-text-field
      v-model="account.name"
      :counter="50"
      :rules="nameRules"
      label="Nombre"
      required
    ></v-text-field>

    <v-text-field
      label="Usuario"
      v-model="account.user"
      :counter="20"
      :rules="userRules"
      :error-messages="messageErrorName"
      :error="nameExist"
      @keypress="cleanInput"
      required
    ></v-text-field>

    <v-text-field
      label="Correo Electrónico"
      v-model="account.mail"
      :rules="mailRules"
      :error-messages="messageErrorMail"
      :error="mailExist"
      @keypress="cleanInput"
      required
    ></v-text-field>

    <v-text-field
      v-model="account.password"
      :append-icon="showPass ? 'mdi-eye' : 'mdi-eye-off'"
      :rules="[rules.required, rules.min]"
      :type="showPass ? 'text' : 'password'"
      name="input-10-1"
      label="Contraseña"
      hint="Mínimo 8 caracteres"
      counter
      @click:append="showPass = !showPass"
    ></v-text-field>

    <v-divider class="mb-5 mt-2"></v-divider>

    <v-btn
      block
      class="mr-4"
      color="pink accent-3"
      :disabled="loading"
      :loading="loading"
      @click="register"
    >
      Registrar
    </v-btn>

    <div align="center" class="mt-5">
      ¿Ya tienes una cuenta?
      <v-btn text dark x-small @click="toLogin"> clic aquí </v-btn>
    </div>
  </v-form>
</template>

<script lang="ts">
import { VForm } from 'types'
import { Vue, Component, Ref, getModule } from 'nuxt-property-decorator'
import RegisterStore from '@/store/register'
@Component({
  name: 'register-form',
})
export default class RegisterForm extends Vue {
  @Ref('form') readonly form!: VForm

  valid = true

  nameRules = [
    (v: any) => !!v || 'Digite su nombre.',
    (v: any) =>
      (v && v.length <= 50) || 'El nombre debe tener menos de 50 caracteres.',
  ]

  userRules = [
    (v: any) => !!v || 'Digite su usuario.',
    (v: any) =>
      (v && v.length <= 20) || 'El usuario debe tener menos de 20 caracteres.',
  ]

  mailRules = [
    (v: any) => !!v || 'Digite su correo electrónico.',
    (v: any) => /.+@.+\..+/.test(v) || 'Digite un correo electrónico válido.',
  ]

  showPass = false
  rules = {
    required: (value: any) => !!value || 'Digite su contraseña.',
    min: (v: any) =>
      !v || v.length >= 8 || 'La contraseña debe tener al menos 8 caracteres.',
  }

  account = {
    name: '',
    user: '',
    mail: '',
    password: '',
  }

  messageErrorName = ''
  nameExist = false
  messageErrorMail = ''
  mailExist = false

  loading = false

  register() {
    this.loading = true
    const register = getModule(RegisterStore, this.$store)
    if (this.form.validate()) {
      register
        .registerAction(this.account)
        .then((res) => {
          this.loading = false
          this.$router.push('/login')
        })
        .catch((err) => {
          this.loading = false
          if (
            err.response.status === 500 &&
            Object.keys(err.response.data.error.keyValue)[0] === 'user'
          ) {
            console.log('ya existe el usuario')
            this.messageErrorName = 'Ya existe el usuario'
            this.nameExist = true
            return
          }
          if (
            err.response.status === 500 &&
            Object.keys(err.response.data.error.keyValue)[0] === 'mail'
          ) {
            console.log('ya existe el correo')
            this.messageErrorMail = 'Ya existe el correo'
            this.mailExist = true
            return
          }
        })
    } else {
      this.loading = false
    }
  }

  reset() {
    this.form.reset()
  }
  
  resetValidation() {
    this.form.resetValidation()
  }
  
  cleanInput() {
    this.form.resetValidation()
    this.messageErrorName = ''
    this.nameExist = false
    this.messageErrorMail = ''
    this.mailExist = false
  }

  toLogin() {
    this.$router.push('/login')
  }
}
</script>